package com.njyunzhi.avatar.person.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.njyunzhi.avatar.common.BaseController;
import com.njyunzhi.avatar.common.ResponseBean;
import com.njyunzhi.avatar.person.entity.TaPerson;
import com.njyunzhi.avatar.person.vo.RankItem;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import com.njyunzhi.avatar.person.entity.StRank;
import com.njyunzhi.avatar.person.service.StRankService;

/**
 * 统计排行;(st_rank)表控制层
 *
 * @author : http://njyunzhi.com
 * @date : 2022-9-27
 */
@Api(tags = "统计排行对象功能接口")
@RestController
@RequestMapping("/wx")
public class StRankController extends BaseController {

    @Autowired
    private StRankService stRankService;

    /**
     * 分页查询
     *
     * @param pageNum  当前页码
     * @param pageSize 每页条数
     * @return 查询结果
     */
    @ApiOperation("分页查询")
    @GetMapping("/stRank")
    public ResponseBean list(@ApiParam("页码") @RequestParam(value = "pageNum", defaultValue = "1") Integer pageNum,
                             @ApiParam("单页数据量") @RequestParam(value = "pageSize", defaultValue = "10") Integer pageSize,
                             @ApiParam("排行类型") @RequestParam(value = "type") String type) throws Exception {

        IPage<RankItem> pg = new Page<>(pageNum, pageSize);
        IPage<RankItem> result = stRankService.getPageBy(pg, type);

        return ResponseBean.success(result);
    }


    /**
     * 更新数据传递人员
     *
     * @return 实例对象
     */
    @ApiOperation("获取排行")
    @GetMapping("/stRank/{type}/{code}")
    public ResponseBean getRank(@ApiParam("排行类型") @PathVariable String type,
                                @ApiParam("排行编码") @PathVariable String code) throws Exception {
//         TaPerson taPerson = currentPerson();

        long rank = stRankService.getRankBy(type, code);
        return ResponseBean.success(rank);
    }

}