package com.njyunzhi.avatar.person.controller;

import cn.binarywang.wx.miniapp.bean.WxMaJscode2SessionResult;
import cn.dev33.satoken.stp.StpUtil;
import com.njyunzhi.avatar.common.BaseController;
import com.njyunzhi.avatar.common.ResponseBean;
import com.njyunzhi.avatar.common.StringUtils;
import com.njyunzhi.avatar.common.WxUtils;
import com.njyunzhi.avatar.person.entity.TaPerson;
import com.njyunzhi.avatar.person.service.StRankService;
import com.njyunzhi.avatar.person.service.TaPersonService;
import com.njyunzhi.avatar.person.vo.MaLogin;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.time.LocalDateTime;
import java.util.HashMap;
import java.util.Map;

@Api(tags = "小程序登入/登出")
@RestController
@RequestMapping("/wx")
public class WxMaController extends BaseController {

    @Autowired
    TaPersonService iTaPersonService;

    @Autowired
    StRankService stRankService;

    @Autowired
    WxUtils wxUtils;

    /**
     *
     * 小程序
     * @param loginParam
     * @return
     * @throws Exception
     */
    @PostMapping("/login")
    @ApiOperation(value="小程序登录", notes = "小程序登录", httpMethod = "POST", response = ResponseBean.class)
    public ResponseBean login(@ApiParam("登录参数") @RequestBody MaLogin loginParam) throws Exception {

        String code = loginParam.getCode();
        WxMaJscode2SessionResult sessionInfo = wxUtils.getMaService().getUserService().getSessionInfo(code);
        String openid = sessionInfo.getOpenid();
        String sessionKey = sessionInfo.getSessionKey();

        TaPerson taPerson = iTaPersonService.getExistBy("openid", openid, false, true);
        if (null == taPerson) {
            taPerson = new TaPerson();
            taPerson.setOpenid(openid);
            taPerson.setRecommender(loginParam.getRecommender());
            taPerson.setCreateDate(LocalDateTime.now());
            iTaPersonService.save(taPerson);
            //
            stRankService.createRank("person", taPerson.getPersonId().toString());
        }

        if (null != loginParam.getRecommender()) {
            stRankService.updateByPerson(taPerson.getRecommender());
        }

        StpUtil.login(taPerson.getPersonId(), "miniapp");
        Map<String, Object> res = new HashMap<>();
        res.put("person", taPerson);
        res.put("token", StpUtil.getTokenValue());
        res.put("sessionKey", sessionKey);

        return ResponseBean.success(res);
    }

//    @PutMapping("/auth-user")
//    @ApiOperation(value="授权头像", notes = "授权头像", httpMethod = "PUT", response = TaPerson.class)
//    public ResponseBean updateUserInfo(@ApiParam("客户端ID") @PathVariable String clientId,
//                                       @ApiParam("授权头像的参数") @RequestBody WxMaAuthParam params) throws Exception {
//        WxMaService service = wxUtils.getMaService();
//        checkAuthParams(service, params);
//
//        // 解密用户信息
//        WxMaUserInfo userInfo = service.getUserService().getUserInfo(params.getSessionKey(), params.getEncryptedData(), params.getIv());
//
//        TaPerson taPerson = currentPerson();
//        if (null == taPerson) {
//            throw new Exception("校验当前人员失败, 请重试");
//        }
//
//        taPerson.setAvatar(userInfo.getAvatarUrl());
//        taPerson.setNickName(userInfo.getNickName());
//        taPerson.setSex(Integer.parseInt(userInfo.getGender()));
//
//        iTaPersonService.updateById(taPerson);
//
//        return ResponseBean.success(taPerson);
//    }
//
//    @ApiOperation(value="授权手机", notes = "授权手机", httpMethod = "PUT", response = TaPerson.class)
//    @PutMapping("/auth-phone")
//    public ResponseBean updateUserPhone(@ApiParam("客户端ID") @PathVariable String clientId,
//                                        @ApiParam("授权手机的参数") @RequestBody WxMaAuthParam params) throws Exception {
//
//        WxMaService service = wxUtils.getMaService();
//
//        // 解密
//        WxMaPhoneNumberInfo phoneNoInfo = service.getUserService().getPhoneNoInfo(params.getSessionKey(), params.getEncryptedData(), params.getIv());
//
//        TaPerson taPerson = currentPerson();
//        if (null == taPerson) {
//            throw new Exception("校验当前人员失败, 请重试");
//        }
//
//        taPerson.setPhone(phoneNoInfo.getPhoneNumber());
//        iTaPersonService.updateById(taPerson);
//
//        return ResponseBean.success(taPerson);
//    }
//
//
//    private void checkAuthParams(WxMaService service, WxMaAuthParam params) throws Exception {
//        String signature = params.getSignature();
//        String rawData = params.getRawData();
//        String encryptedData = params.getEncryptedData();
//        String iv = params.getIv();
//        String sessionKey = params.getSessionKey();
//
//        if (StringUtils.isEmpty(signature) || StringUtils.isEmpty(rawData) || StringUtils.isEmpty(encryptedData) || StringUtils.isEmpty(iv) || StringUtils.isEmpty(sessionKey)) {
//            throw new Exception("缺失授权参数");
//        }
//
//        boolean isValid = service.getUserService().checkUserInfo(sessionKey, rawData, signature);
//        if (!isValid) {
//            throw new Exception("校验授权参数失败, 请重试");
//        }
//    }
}
