package com.njyunzhi.avatar.person.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.TableId;
import java.io.Serializable;
import java.time.LocalDateTime;
import java.util.Date;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * 人员表;
 * @author : http://www.chiner.pro
 * @date : 2022-9-27
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "人员表",description = "")
@TableName("ta_person")
public class TaPerson implements Serializable,Cloneable{
    /** 人员ID */
    @ApiModelProperty(name = "人员ID",notes = "")
    @TableId(value = "person_id", type = IdType.AUTO)
    private Integer personId ;
    /** openid */
    @ApiModelProperty(name = "openid",notes = "")
    private String openid ;
    /** 昵称 */
    @ApiModelProperty(name = "昵称",notes = "")
    private String nickname ;
    /** 头像 */
    @ApiModelProperty(name = "头像",notes = "")
    private String avatar ;
    /** 状态 */
    @ApiModelProperty(name = "状态",notes = "")
    @TableField("`status`")
    private Integer status ;
    /** 创建时间 */
    @ApiModelProperty(name = "创建时间",notes = "")
    private LocalDateTime createDate ;
    /** 分享人 */
    @ApiModelProperty(name = "分享人",notes = "")
    private Integer recommender ;
    /** 分享人数 */
    @ApiModelProperty(name = "分享人数",notes = "")
    private Integer shareNum ;
    /** 定位 */
    @ApiModelProperty(name = "定位",notes = "")
    private String location ;
    /** 所在区域 */
    @ApiModelProperty(name = "所在区域",notes = "")
    private String areaCode ;

}